//---------------------------------------------------------------------------
#ifndef mainH
#define mainH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <vcl\inifiles.hpp>
#include "rtklib.h"
//---------------------------------------------------------------------------
class TMainForm : public TForm
{
__published:
	TButton *BtnExec;
	TButton *BtnExit;
	TButton *BtnToKML;
	TOpenDialog *OpenDialog;
	TButton *BtnView;
	TPanel *Panel1;
	TGroupBox *GroupBox1;
	TComboBox *InputFile1;
	TComboBox *InputFile2;
	TButton *BtnInputFile1;
	TButton *BtnInputFile2;
	TGroupBox *GroupBox2;
	TButton *BtnOutputFile;
	TPanel *Panel2;
	TLabel *Message;
	TProgressBar *Progress;
	TGroupBox *GroupBox3;
	TRadioButton *RefType1;
	TRadioButton *RefType2;
	TCheckBox *RefPos;
	TButton *BtnPlot;
	TButton *BtnOption;
	TEdit *RefPos1;
	TEdit *RefPos2;
	TEdit *RefPos3;
	TButton *BtnRefPos;
	TComboBox *OutputFile;
	TButton *BtnInputViiew1;
	TButton *BtnInputView2;
	TSaveDialog *SaveDialog;
	TGroupBox *GroupBox4;
	TCheckBox *TimeStart;
	TEdit *TimeY1;
	TEdit *TimeH1;
	TEdit *TimeY2;
	TEdit *TimeH2;
	TEdit *TimeInt;
	TLabel *LabelTimeTo;
	TComboBox *InputFile3;
	TButton *BtnInputView3;
	TButton *BtnInputFile3;
	TCheckBox *TimeIntF;
	TCheckBox *TimeEnd;
	TLabel *LabelTimeInt;
	void __fastcall BtnExitClick(TObject *Sender);
	void __fastcall PosModeChange(TObject *Sender);
	void __fastcall BtnInputFile1Click(TObject *Sender);
	void __fastcall BtnInputFile2Click(TObject *Sender);
	void __fastcall BtnInputFile3Click(TObject *Sender);
	void __fastcall BtnOutputFileClick(TObject *Sender);
	void __fastcall SolFormatChange(TObject *Sender);
	void __fastcall BtnExecClick(TObject *Sender);
	void __fastcall BtnToKMLClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
	void __fastcall BtnViewClick(TObject *Sender);
	void __fastcall BtnStopClick(TObject *Sender);
	void __fastcall SolutionChange(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall RefType1Click(TObject *Sender);
	void __fastcall RefType2Click(TObject *Sender);
	void __fastcall RefPosClick(TObject *Sender);
	void __fastcall BtnPlotClick(TObject *Sender);
	void __fastcall BtnOptionClick(TObject *Sender);
	void __fastcall BtnRefPosClick(TObject *Sender);
	void __fastcall BtnInputViiew1Click(TObject *Sender);
	void __fastcall BtnInputView2Click(TObject *Sender);
	void __fastcall BtnInputView3Click(TObject *Sender);
	void __fastcall TimeStartClick(TObject *Sender);
	void __fastcall TimeIntFClick(TObject *Sender);
private:
	int RefType;
	void __fastcall UpdateEnable(void);
	int __fastcall GetOption(opt_t &opt);
	void __fastcall GetRefPos(double *rb);
	void __fastcall AddHist(TComboBox *combo);
	TStringList * __fastcall ReadList(TIniFile *ini, AnsiString cat,
		AnsiString key);
	void __fastcall WriteList(TIniFile *ini, AnsiString cat,
		AnsiString key, TStrings *list);
public:
	int PosMode,Freq,Solution,Datum,DynamicModel,IonoEst,TropEst;
	int OutCntResetBias,LockCntFixAmb,AntPcvCorr,AmbRes;
	int SolFormat,TimeFormat,LatLonFormat,IntpRefObs,NetRSCorr,SatClkCorr;
	double ElMask,MaxAgeDiff,RejectThres,MeasErr1,MeasErr2,MeasErr3,MeasErr4;
	double SatClkStab,RovAntE,RovAntN,RovAntU,RefAntE,RefAntN,RefAntU;
	double PrNoise1,PrNoise2,PrNoise3,ValidThresAR;
	AnsiString FieldSep,RovAnt,RefAnt,AntPcvFile;
	AnsiString NetRSCorrFile,SatClkCorrFile,GoogleEarthFile;
	TStringList *RefList;
	__fastcall TMainForm(TComponent* Owner);
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
