//---------------------------------------------------------------------------
#include <vcl.h>
#include <stdio.h>
#pragma hdrstop

#include "main.h"
#include "refdlg.h"
#include "rtklib.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TRefDialog *RefDialog;
//---------------------------------------------------------------------------
__fastcall TRefDialog::TRefDialog(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::FormShow(TObject *Sender)
{
	AnsiString s;
	SetRef(MainForm->RefList);
	RefInput->Text=s.sprintf("%13.9f %14.9f %10.4f : ",Pos[0],Pos[1],Pos[2]);
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::FormClose(TObject *Sender, TCloseAction &Action)
{
	GetRef(MainForm->RefList);
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::BtnAddClick(TObject *Sender)
{
	double pos[3];
	char name[128]="";
	if (sscanf(RefInput->Text.c_str(),"%lf %lf %lf : %s",pos,pos+1,pos+2,name)<3) return;
	AddRef(pos,name);
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::BtnDeleteClick(TObject *Sender)
{
	int n=RefLists->RowCount;
	TGridRect r=RefLists->Selection; if (r.Top<0||n-1<=r.Top) return;
	for (int i=0,j=0;i<n;i++) {
		if (i==r.Top) continue;
		for (int k=0;k<4;k++) RefLists->Cells[k][j]=RefLists->Cells[k][i];
		j++;
	}
	if (n>1) RefLists->RowCount=n-1;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::RefListsDblClick(TObject *Sender)
{
	ModalResult=InputRef()?mrOk:mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::BtnOKClick(TObject *Sender)
{
	ModalResult=InputRef()?mrOk:mrCancel;
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::SetRef(TStringList *list)
{
	double pos[3];
	char name[128]="";
	RefLists->RowCount=1;
	for (int i=0;i<4;i++) RefLists->Cells[i][0]="";
	for (int i=0;i<list->Count;i++) {
		name[0]='\0';
		if (sscanf(list->Strings[i].c_str(),"%lf %lf %lf : %s",
		    pos,pos+1,pos+2,name)<3) continue;
		AddRef(pos,name);
	}
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::GetRef(TStringList *list)
{
	list->Clear();
	for (int i=0;i<RefLists->RowCount-1;i++) {
		list->Add(RefLists->Cells[0][i]+" "+RefLists->Cells[1][i]+" "+
		          RefLists->Cells[2][i]+" :"+RefLists->Cells[3][i]);
	}
}
//---------------------------------------------------------------------------
void __fastcall TRefDialog::AddRef(double *pos, const char *name)
{
	AnsiString s;
	int n=RefLists->RowCount;
	RefLists->Cells[0][n-1]=s.sprintf("%13.9f",pos[0]);
	RefLists->Cells[1][n-1]=s.sprintf("%14.9f",pos[1]);
	RefLists->Cells[2][n-1]=s.sprintf("%10.4f",pos[2]);
	RefLists->Cells[3][n-1]=name;
	RefLists->RowCount=n+1;
}
//---------------------------------------------------------------------------
int __fastcall TRefDialog::InputRef(void)
{
	int n=RefLists->RowCount;
	TGridRect r=RefLists->Selection; if (r.Top<0||n-1<=r.Top) return 0;
	Pos[0]=RefLists->Cells[0][r.Top].ToDouble();
	Pos[1]=RefLists->Cells[1][r.Top].ToDouble();
	Pos[2]=RefLists->Cells[2][r.Top].ToDouble();
	return 1;
}
//---------------------------------------------------------------------------

